/*///////////////////////////////////////////////////////////////////////////
	
	Soubor: WinApiComboBoxEx.cpp
	
	(C) 2002 Radek Chalupa
	
///////////////////////////////////////////////////////////////////////////*/

#define WINVER 0x0500
#define _WIN32_WINNT 0x0501

#include <windows.h>
#include <tchar.h>
#include <commctrl.h>
#include <stdio.h>

#include "resource.h"

#pragma comment (lib,"comctl32.lib")

HIMAGELIST g_hImageList;

BOOL NaInitDialog(HWND hWnd)
{
	HWND hCombo = CreateWindowEx(0,
		WC_COMBOBOXEX,
		NULL,
		WS_BORDER | WS_VISIBLE | WS_CHILD | CBS_DROPDOWN,
		0, 0,	0, 100, // polohu a rozmry nastvme pozdji
		hWnd,
		(HMENU)IDC_COMBOEX, // nastavme ID pro snadnj pouit
		GetModuleHandle(NULL),
		NULL);
	g_hImageList = ImageList_LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(IDB_IMAGELIST),
		16, 3, 0x0000FF00);
	if ( !g_hImageList )
		return FALSE;
	SendMessage(hCombo, CBEM_SETIMAGELIST, 0, (LPARAM)g_hImageList);
	SetWindowPos(hCombo, NULL,10,32,250,120,SWP_NOACTIVATE | SWP_NOZORDER);
	COMBOBOXEXITEM cbei;
	// Naplnme ComboBox 4 polokami.
	ZeroMemory(&cbei, sizeof(cbei));
	cbei.mask = CBEIF_IMAGE | CBEIF_TEXT | CBEIF_SELECTEDIMAGE;
	cbei.pszText = _T("prvn poloka");
	cbei.iImage = 0;
	cbei.iItem = 0;
	cbei.iSelectedImage = 0;
	SendMessage(hCombo, CBEM_INSERTITEM, 0, (LPARAM)&cbei);
	cbei.pszText = _T("druh poloka");
	cbei.iImage = 1;
	cbei.iItem = 1;
	cbei.iSelectedImage = 1;
	SendMessage(hCombo, CBEM_INSERTITEM, 0, (LPARAM)&cbei);
	cbei.mask = CBEIF_IMAGE | CBEIF_TEXT | CBEIF_SELECTEDIMAGE;
	cbei.pszText = _T("tet poloka");
	cbei.iImage = 2;
	cbei.iItem = 2;
	SendMessage(hCombo, CBEM_INSERTITEM, 0, (LPARAM)&cbei);
	cbei.mask = CBEIF_IMAGE | CBEIF_TEXT | CBEIF_SELECTEDIMAGE;
	cbei.pszText = _T("tvrt poloka");
	cbei.iImage = 3;
	cbei.iItem = 3;
	cbei.iSelectedImage = 3;
	SendMessage(hCombo, CBEM_INSERTITEM, 0, (LPARAM)&cbei);
	// Nastavme vchoz vbr
	SendMessage(hCombo, CB_SETCURSEL, 1, 0);
	
	// Zjistme "dtsk" ComboBox a prvek Edit
	HWND hChildCombo = (HWND)SendMessage(hCombo, CBEM_GETCOMBOCONTROL, 0,0);
	HWND hEdit = (HWND)SendMessage(hCombo, CBEM_GETEDITCONTROL, 0,0);
	// Nastavme vlastn kurzory
	SetClassLongPtr(hChildCombo, GCLP_HCURSOR,
		(LONG_PTR)LoadCursor(GetModuleHandle(NULL), MAKEINTRESOURCE(IDC_CURSOR1)));
	SetClassLongPtr(hEdit, GCLP_HCURSOR,
		(LONG_PTR)LoadCursor(GetModuleHandle(NULL), MAKEINTRESOURCE(IDC_CURSOR2)));
	return TRUE;
}

void NaSelChange(HWND hWnd)
{
	TCHAR szText[100];
	COMBOBOXEXITEM cbei;
	ZeroMemory(&cbei, sizeof(cbei));
	cbei.mask = CBEIF_IMAGE | CBEIF_TEXT;
	cbei.pszText = szText;
	cbei.cchTextMax = sizeof(szText);
	// index vybran poloky
	cbei.iItem = SendDlgItemMessage(hWnd, IDC_COMBOEX, CB_GETCURSEL, 0, 0);
	SendDlgItemMessage(hWnd, IDC_COMBOEX, CBEM_GETITEM,	0, (LPARAM)&cbei);
	SetDlgItemText(hWnd, IDC_COMBO_TEXT, szText);
	SendDlgItemMessage(hWnd, IDC_IMAGE, STM_SETIMAGE, IMAGE_ICON,
		(LPARAM)ImageList_GetIcon(g_hImageList, cbei.iImage, ILD_NORMAL));
}

/////////////////////////////////////////////////////////////////////////////
// Procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_COMBOEX:
					if ( HIWORD(wParam) == CBN_SELCHANGE )
						NaSelChange(hWnd);
					break;
			}
			break;
			
		case WM_INITDIALOG:
			NaInitDialog(hWnd);
			NaSelChange(hWnd);
			break;
	}
	return FALSE;
}



/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu pro Windows

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icc.dwICC = ICC_WIN95_CLASSES  | ICC_USEREX_CLASSES;
	if ( !InitCommonControlsEx(&icc) )
	  return -1;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_HLAVNI), NULL, DialogProc);
	return 0;
}
